-- Honor Kills Counter - World of Warcraft AddOn created by Torven aka Torvie of WoW Classic server Fairbanks.
-- This file may be distributed so long as it remains unaltered.
-- This code is NOT open source.  You may not fork it without permission.  Although I doubt you'd want to anyway.
-- If you want to copy a small piece of this or two for an original addon I don't care.
-- Yes this code is a mess and the conventions are bad.  It's old

HKC_MAX_HISTORY = 100;
HKC_MAX_LEVEL = 60;

HKC_CFG = {};
HKC_CFG_DEFAULTS = {
	chatMessages = true,
	chatMessagesHK = true,
	onClickMsg = true,
	maxRecords = 500,
	maxArenaRecords = 20,
	doNotOpen = false,
	resetHour = 2,
	movableFrame = false,
	tooltipKills = true,
};
HKC_BGHISTORY_LABELS = nil;
HKC_BGHISTORY_BRACKET_LABELS = nil;
HKC_VEHICLE = BINDING_HEADER_VEHICLE:sub(1, BINDING_HEADER_VEHICLE:find(" "));		-- get a localized "Vehicle" string

HKC_Server = "";
HKC_PlayerName = "";
HKC_Player = "";

local HKC_Debug = false;
local HKC_LastWinTimestamp = 0;
--local HKC_LastEstimated = 0;
local HKC_InBattleground = false;
local HKC_Map = "";				-- the BG map the player was just in (or is in)
local HKC_LastScore = 0;
local HKC_LastStats = 0;
local HKC_GotArenaScores = false;
local HKC_LastArenaSize = nil;
local HKC_LoginDelay = 0;

-- battleground outcome variables
local HKC_Winner = nil;
local HKC_Bracket = nil;
local HKC_isArena = nil;
local HKC_EnterTime = 0;
local HKC_Participants = 0;
local HKC_PremadePctA = 0;
local HKC_PremadePctH = 0;
local HKC_AFKA = 0;
local HKC_AFKH = 0;
local HKC_KBs = 0;
local HKC_Dmg = 0;
local HKC_Healing = 0;
local HKC_KBPlace = 0;
local HKC_DamagePlace = 0;
local HKC_HealingPlace = 0;
local HKC_Deaths = 0;
local HKC_AllianceScore = -1;
local HKC_HordeScore = -1;
local HKC_JoinedLate = 0;
local HKC_KillHonor = 0;
local HKC_BonusHonor = 0;
local HKC_ScoreboardBonusHonor = 0;

-- UI drop down selections
HKC_Selected = 1;
HKC_BGHistory_Selected = 1;
HKC_BGHistoryBracket_Selected = 1;

local HKC_FrameText = {};		-- the text displayed in the UI text window scroll frame
local HKC_ZoneInTime = {};		-- to track the zone in time of players in the BG
local HKC_LastSort = 0;			-- the last sorted column in the table frame display
local HKC_DB = {};				-- the references to the records the table displays.  can sort this w/o altering the record tables

function HKC_OnLoad(self)
	SlashCmdList["HKC"] = HKCCmdLine;
	SLASH_HKC1 = "/hkc"; 

	self:RegisterEvent("PLAYER_LOGIN");
	self:RegisterEvent("CHAT_MSG_COMBAT_HONOR_GAIN");
--	self:RegisterEvent("UNIT_NAME_UPDATE");
	self:RegisterEvent("PLAYER_TARGET_CHANGED");
	self:RegisterEvent("UPDATE_MOUSEOVER_UNIT");
	self:RegisterEvent("UPDATE_BATTLEFIELD_SCORE");
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	self:RegisterEvent("CHAT_MSG_RAID_BOSS_EMOTE");
	self:RegisterEvent("CHAT_MSG_LOOT");
	self:RegisterEvent("INSPECT_HONOR_UPDATE");

	if (DEFAULT_CHAT_FRAME) then
		DEFAULT_CHAT_FRAME:AddMessage(HKC_LOGINMSG);
	end
end

function HKC_CheckResetToday(forceReset)

	local d = date("*t");
	local yday, hour = d.yday, d.hour;
	local dayDiff;
	
	if ( not HKC_PlayerData.yday ) then
		HKC_PlayerData.yday = yday - 1;
	end
	
	dayDiff = yday - HKC_PlayerData.yday;
	if ( dayDiff < 0 ) then
		dayDiff = dayDiff + 365;
	end

	if ( dayDiff > 1 or (dayDiff == 1 and hour >= HKC_CFG.resetHour) or forceReset ) then

		if ( HKC_Debug ) then
			print("Daily kill reset; HKC_PlayerData.yday, dayDiff, yday, hour ==", HKC_PlayerData.yday, dayDiff, yday, hour);
		end
		if ( HKC_PlayerData.blizzHonorToday > 0 ) then
			DEFAULT_CHAT_FRAME:AddMessage(HKC_RESET..HKC_PlayerData.honorToday, 1, 0, 0);
		end
		
		HKC_KillsToday = {};
		HKC_PlayerData.yday = yday;
		HKC_PlayerData.honorToday = 0;
		HKC_PlayerData.blizzHonorToday = 0;
	end
end

function HKC_CheckResetThisWeek(forceReset)

	local d = date("*t");
	local year, yday, wday, hour = d.year, d.yday, d.wday, d.hour;
	local noReset = false;

	if ( HKC_Debug ) then
		print("HKC: ResetThisWeek() year, yday, wday ==", year, yday, wday);
	end

	-- don't reset before the expected reset day (Tuesday)
	if ( HKC_ServerData[HKC_Server].resetDay and not forceReset ) then
	
		local dayDiff = HKC_ServerData[HKC_Server].resetDay - yday;
		
		if ( dayDiff > 0 or (dayDiff == 0 and hour < HKC_CFG.resetHour) ) then
			if ( HKC_Debug ) then
				print("HKC: Not checking for next week stats because dayDiff > 0 or (dayDiff == 0 and hour < HKC_CFG.resetHour)");
			end
			noReset = true;
		end
		if ( HKC_ServerData[HKC_Server].resetDay < 8 and yday > 358 ) then
			if ( HKC_Debug ) then
				print("HKC: Not resetting standings because newyear");
			end
			noReset = true;
		end
	end

	-- if last inspection was a long time ago, reset
	if ( HKC_ServerData[HKC_Server].lastInspectDay ) then
	
		local lastInspectDiff = yday - HKC_ServerData[HKC_Server].lastInspectDay;
		if ( lastInspectDiff < 0 ) then
			lastInspectDiff = lastInspectDiff + 365;
		end
		
		if ( lastInspectDiff > 21 ) then
		
			HKC_WBLStandings[HKC_Server] = {};
			HKC_Standings[HKC_Server] = {};
			if ( HKC_Debug ) then
				print("HKC: Wiping all standings data because last inspect was >21 days ago");
			end
			noReset = true;
			
		elseif ( #HKC_Standings[HKC_Server] > 0 and lastInspectDiff > 14 ) then
			if ( HKC_Debug ) then
				print("HKC: Resetting standings data because last inspect was > 14 days ago");
			end
			forceReset = true;
		end
	end
	
	local hk, dk, contribution, rank = GetPVPLastWeekStats();
	if ( HKC_Debug ) then
		print("HKC: GetPVPLastWeekStats() ==", hk, dk, contribution, rank);
	end

	if (HKC_PlayerData.lastWeekHKs ~= hk or
		HKC_PlayerData.lastWeekDKs ~= dk or
		HKC_PlayerData.LastWeekHonor ~= contribution or
		HKC_PlayerData.LastWeekRank ~= rank or
		forceReset
	) then
		-- new week
		HKC_PlayerData.lastWeekHKs = hk;
		HKC_PlayerData.lastWeekDKs = dk;
		HKC_PlayerData.LastWeekHonor = contribution;
		HKC_PlayerData.LastWeekRank = rank;

		if ( forcereset or not noReset ) then
		
			HKC_WBLStandings[HKC_Server] = HKC_Standings[HKC_Server];	-- last week standings
			HKC_Standings[HKC_Server] = {};
			
			local plusDays = 7;
			if ( wday > 3 ) then
				plusDays = 10 - wday;
			elseif ( wday < 3 ) then
				plusDays = 3 - wday;
			end
			
			-- don't check again until next Tuesday to prevent resets from checking honor of alt characters
			HKC_ServerData[HKC_Server].resetDay = yday + plusDays;
			
			if ( HKC_ServerData[HKC_Server].resetDay > 365 ) then
				HKC_ServerData[HKC_Server].resetDay = HKC_ServerData[HKC_Server].resetDay - 365;
			end

			DEFAULT_CHAT_FRAME:AddMessage("HKC standings reset", 1, 0, 0);
		end
		
		if (rank) then
			local pvpname, pvprank;
			pvpname, pvprank = GetPVPRankInfo(UnitPVPRank("player"));
			HKC_Standings[HKC_Server][rank] = {
				name = UnitName("player"),
				ranktitle = pvpname,
				ranknum = pvprank,
				class = UnitClass("player"),
				HKs = hk,
				contribution = contribution,
				progress = GetPVPRankProgress(),
			};
		end
	end
end

function HKCLogin()
	HKC_Server = GetRealmName();
	HKC_PlayerName = UnitName("player");
	HKC_Player = HKC_PlayerName.." "..HKC_Server;

	local vars = {
		"HKC_PlayerData",
		"HKC_ServerData",
		"HKC_KillsToday",
		"HKC_KillsLifetime",
		"HKC_Standings",
		"HKC_WBLStandings",
		"HKC_BonusHistory",
		"HKC_BGHistory",
		"HKC_ArenaHistory",
		"HKC_TotalWinLoss"
	};
	
	for _, v in ipairs(vars) do
		if ( not _G[v] ) then
			_G[v] = {};
		end
	end
	
	vars = {
		"honorToday",
		"blizzHonorToday",
		"lastWeekHKs",
		"lastWeekDKs",
		"LastWeekHonor",
		"LastWeekRank"
	};

	for _, v in ipairs(vars) do
		if ( not HKC_PlayerData[v] ) then
			HKC_PlayerData[v] = 0;
		end
	end

	if ( not HKC_ServerData[HKC_Server] ) then
		HKC_ServerData[HKC_Server] = {};
	end
	if ( not HKC_BGHistory[HKC_Server] ) then
		HKC_BGHistory[HKC_Server] = {};
	end
	if ( not HKC_TotalWinLoss[HKC_Server] ) then
		HKC_TotalWinLoss[HKC_Server] = {};
	end
	if ( not HKC_Standings[HKC_Server] ) then
		HKC_Standings[HKC_Server] = {};
	end
	if ( not HKC_WBLStandings[HKC_Server] ) then
		HKC_WBLStandings[HKC_Server] = {};
	end

	-- add defaults to config
	local k, v;
	for k, v in pairs(HKC_CFG_DEFAULTS) do
		if ( type(HKC_CFG[k]) == "nil" ) then
			print("HKC_CFG["..k.."] == nil; setting default to", v);
			HKC_CFG[k] = v;
		end
	end
	
	-- execute logic for checkbox option settings if needed
	for id, t in pairs(HKC_CONFIG_OPTIONS) do
		HKCOptionsCheckButtonToggle(id, HKC_CFG[t.value]);
	end
	
	-- hook arena details frame to hide/show HKC panel when clicked
	HonorFrame:HookScript("OnShow", HKCOpenFrame);
	HonorFrame:HookScript("OnHide", HKCCloseFrame);
	
	if ( HKC_PlayerName == "Torvie" or HKC_PlayerName == "Torven" ) then
		HKC_Debug = true;
	end
end

function HKC_GetBracket(level, map, teamSize)
if ( HKC_Debug ) then
	print("HKC_GetBracket() level, map, teamsize ==", level, map, teamSize);
end
	local low, high;
	
	if ( (map and map == HKC_ALTERAC_VALLEY) or (teamSize and teamSize >= 30) ) then
	
		if ( level % 10 == 0 ) then
			high = level;
			low = high - 9;
		else
			low = level - (level % 10) + 1;
			high = level - (level % 10) + 10;
		end
	else
		low = level - (level % 10);
		high = low + 9;
		if ( high > HKC_MAX_LEVEL ) then
			high = HKC_MAX_LEVEL;
		end
	end
	
	return low.."-"..high;
end

function HKC_AddHistory(s)
	table.insert(HKC_BonusHistory, s);

	local i, n;

	n = #HKC_BonusHistory;
	if ( n > HKC_MAX_HISTORY ) then
		for i = 1, (n - HKC_MAX_HISTORY) do
			table.remove(HKC_BonusHistory, 1);
		end
	end
end

function HKC_BonusHistoryOnExit()
	-- call this after player just left a BG

	if ( HKC_isArena ) then
		return
	end
	if ( not HKC_Map or HKC_Map == "Eastern Kingdoms" or HKC_Map == "" ) then
		if ( HKC_Debug ) then
			print("HKC: HKC_Map is nil or blank");
		end
		return
	end

	gained = math.floor(HKC_KillHonor + HKC_BonusHonor);
	if ( HKC_Debug ) then
		print("HKC: scoreboard: "..HKC_ScoreboardBonusHonor..";  Kill Honor: "..HKC_KillHonor..";  Loot Honor: "..HKC_BonusHonor);		
	end

	-- wotlk adds HK honor to scoreboard
	-- use higher value if scoreboard shows more
	if ( HKC_ScoreboardBonusHonor > gained ) then
		gained = floor(HKC_ScoreboardBonusHonor);
	end
	HKC_ScoreboardBonusHonor = 0;

	elapsed = math.floor( (time() - HKC_EnterTime) / 60 );

	if ( HKC_CFG.chatMessages ) then
		DEFAULT_CHAT_FRAME:AddMessage( string.format(HKC_ENDBG, HKC_Map or "", elapsed) );
		HKC_KillHonor = math.floor(HKC_KillHonor);
		HKC_BonusHonor = math.floor(HKC_BonusHonor);
		DEFAULT_CHAT_FRAME:AddMessage( string.format(HKC_ENDBG4, tostring(gained), tostring(HKC_KillHonor), tostring(HKC_BonusHonor)) );

		if ( HKC_PremadePctA > 0 or HKC_PremadePctH > 0 ) then
			DEFAULT_CHAT_FRAME:AddMessage( string.format(HKC_ENDBG2, HKC_PremadePctA, HKC_PremadePctH) );
		end
		if ( HKC_AFKA > 0 or HKC_AFKH > 0 ) then
			DEFAULT_CHAT_FRAME:AddMessage( string.format(HKC_ENDBG3, HKC_AFKA, HKC_AFKH) );
		end
	end

	if ( HKC_Debug ) then
		DEFAULT_CHAT_FRAME:AddMessage("KB Place: "..HKC_KBPlace);
		--DEFAULT_CHAT_FRAME:AddMessage("Damage Place: "..HKC_DamagePlace);
		--DEFAULT_CHAT_FRAME:AddMessage("Healing Place: "..HKC_HealingPlace);
		DEFAULT_CHAT_FRAME:AddMessage("Alliance Score: "..HKC_AllianceScore);
		DEFAULT_CHAT_FRAME:AddMessage("Horde Score: "..HKC_HordeScore);

		if ( HKC_Winner ) then
			DEFAULT_CHAT_FRAME:AddMessage("HKC_Winner == "..HKC_Winner);
		else
			DEFAULT_CHAT_FRAME:AddMessage("Left Early");
		end
	end

	-- Honor bonus history
	HKC_AddHistory( string.format(HKC_EXIT_HISTORY1, date(), HKC_Map) );
	if ( HKC_Winner and (HKC_Winner == 0 or HKC_Winner == 1) ) then
		HKC_AddHistory( string.format(_G["VICTORY_TEXT"..HKC_Winner]..";  "..HKC_EXIT_HISTORY2, elapsed, tostring(gained)) );
	else
		HKC_AddHistory( string.format(HKC_EXIT_HISTORY2, elapsed, tostring(gained)) );
	end

	-- BG History

	local victor;
	if ( HKC_Winner ) then		-- 0 == horde, 1 == alliance, 255 == bugged, nil == no winner

		if ( HKC_Winner == 0 or HKC_Winner == 1 ) then
			victor = HKC_Winner;

		elseif ( HKC_AllianceScore >= 0 and HKC_HordeScore >= 0 ) then
			if ( HKC_AllianceScore > HKC_HordeScore ) then
				victor = 1;
			elseif ( HKC_HordeScore > HKC_AllianceScore ) then
				victor = 0;
			else
				victor = 2;
			end
		else
			-- blizzard's function still broken and no score data
			victor = 2;
		end
	else
		victor = 2;
		
		if ( HKC_Map == HKC_WARSONG ) then
			if ( HKC_AllianceScore == 3 or HKC_HordeScore == 3 ) then
				if ( HKC_Debug ) then
					print("HKC Error: HKC_Winner is nil but scoreboard shows 3 captures");
				end
				
				if ( HKC_AllianceScore == 3 and HKC_HordeScore < 3 ) then
					victor = 1;
				elseif ( HKC_HordeScore == 3 and HKC_AllianceScore < 3 ) then
					victor = 0;
				end
			end
		end
	end
	
	local dateStamp = time(date("*t"));		-- today's date in seconds (one big number)

	local bracket;
	if ( not HKC_Bracket ) then	
		bracket = HKC_GetBracket(UnitLevel("player"), HKC_Map, HKC_Participants);		
	else
		bracket = HKC_Bracket;
	end

	if ( bracket ) then
		-- total win loss
		if ( not HKC_TotalWinLoss[HKC_Server][HKC_Map] ) then
			HKC_TotalWinLoss[HKC_Server][HKC_Map] = {};
		end
		if ( not HKC_TotalWinLoss[HKC_Server][HKC_Map][bracket] ) then
			HKC_TotalWinLoss[HKC_Server][HKC_Map][bracket] = {};
		end
		if ( not HKC_TotalWinLoss[HKC_Server][HKC_Map][bracket][HKC_PlayerName] ) then
			HKC_TotalWinLoss[HKC_Server][HKC_Map][bracket][HKC_PlayerName] = { [1] = 0, [2] = 0, [3] = 0 };
		end
		local winLossArr = HKC_TotalWinLoss[HKC_Server][HKC_Map][bracket][HKC_PlayerName];
		winLossArr[victor + 1] = winLossArr[victor + 1] + 1;

		-- bg history
		if ( not HKC_BGHistory[HKC_Server][HKC_Map] ) then
			HKC_BGHistory[HKC_Server][HKC_Map] = {};
		end
		if ( not HKC_BGHistory[HKC_Server][HKC_Map][bracket] ) then
			HKC_BGHistory[HKC_Server][HKC_Map][bracket] = {};
		end

		-- store placement and joined late data all into one integer value to save memory
		local places = HKC_KBPlace + (HKC_DamagePlace * 100) + (HKC_HealingPlace * 10000);
		if ( HKC_JoinedLate == 2 ) then
			places = places + 1000000;
		end
		table.insert(HKC_BGHistory[HKC_Server][HKC_Map][bracket], {
			[1] = dateStamp,
			[2] = victor,
			[3] = gained,
			[4] = elapsed,
			[5] = HKC_PremadePctA,
			[6] = HKC_PremadePctH,
			[7] = HKC_KBs,
			[8] = HKC_Deaths,
			[9] = HKC_PlayerName,
			[10] = places,
			[11] = HKC_AllianceScore,
			[12] = HKC_HordeScore,
		--	[] = HKC_AFKA,
		--	[] = HKC_AFKH,
		--	[] = HKC_Dmg,
		--	[] = HKC_Healing,
		} );
	
		-- remove old records if over the max records limit
		if ( table.getn(HKC_BGHistory[HKC_Server][HKC_Map][bracket]) > HKC_CFG.maxRecords ) then
			local i;
			local n = table.getn(HKC_BGHistory[HKC_Server][HKC_Map][bracket]) - HKC_CFG.maxRecords;

			for i = 1, n do
				table.remove(HKC_BGHistory[HKC_Server][HKC_Map][bracket], 1);
			end
		end
	end

	HKC_PremadePctA = 0;
	HKC_PremadePctH = 0;
	HKC_AFKA = 0;
	HKC_AFKH = 0;
	HKC_KBs = 0;
	HKC_Deaths = 0;
	HKC_Dmg = 0;
	HKC_Healing = 0;
	HKC_Bracket = nil;
	HKC_KBPlace = 0;
	HKC_DamagePlace = 0;
	HKC_HealingPlace = 0;
	HKC_AllianceScore = -1;
	HKC_HordeScore = -1;
	HKC_JoinedLate = 0;
end

function HKC_Timer()

	-- get battlefield stats at least once every 20 seconds
	if ( HKC_LastScore + 20 < time() ) then
		HKC_LastScore = time();
		RequestBattlefieldScoreData();
	end
end

function HKC_Timer2(self)
	if ( HKC_LoginDelay > 0 and HKC_LoginDelay < time() ) then
		HKC_LoginDelay = 0;
		
		HKC_CheckResetThisWeek();
		
		self:Hide();
	end
end

function HKC_OnEvent(self, event, ...)
	local arg1 = ...;

	if ( event == "UPDATE_MOUSEOVER_UNIT" ) then
		if ( HKC_CFG.tooltipKills and UnitExists("mouseover") and HKC_KillsToday[UnitName("mouseover")] ) then
			-- GameTooltipTextRight3:SetText("("..HKC_KillsToday[UnitName("target")].." kills today)");
			-- GameTooltipTextRight3:Show();
			if (GameTooltipTextLeft3:GetText() == "PvP") then
				GameTooltipTextLeft3:SetText("PvP ("..HKC_KillsToday[UnitName("mouseover")]..HKC_KILLSTODAYTEXT..")");
			end
		end

	elseif ( event == "PLAYER_TARGET_CHANGED" and HKC_CFG.onClickMsg ) then
		if (	UnitExists("target")
			and UnitIsPlayer("target")
			and UnitIsEnemy("target", "player")
			and UnitIsPVP("target")
			and not UnitIsTrivial("target")
		) then
			if (HKC_KillsToday[UnitName("target")]) then
				UIErrorsFrame:AddMessage(HKC_KillsToday[UnitName("target")]..HKC_KILLSTODAYTEXT, 1.0, 1.0, 1.0, 1.0, 1);
			else
				UIErrorsFrame:AddMessage(HKC_NEVERKILLED, 1.0, 1.0, 1.0, 1.0, 1);
			end
		end

	elseif (event == "CHAT_MSG_LOOT") then

		if ( string.match(arg1, HKC_HONORGAIN4) ) then

			HKC_BonusHonor = HKC_BonusHonor + 1;
			HKC_PlayerData.honorToday = HKC_PlayerData.honorToday + 1;
			HKC_PlayerData.blizzHonorToday = HKC_PlayerData.blizzHonorToday + 1;

			return
		else

			local points = string.match(arg1, HKC_HONORGAIN5);
			if ( points ) then

				points = tonumber(points);

				HKC_BonusHonor = HKC_BonusHonor + points;
				HKC_PlayerData.honorToday = HKC_PlayerData.honorToday + points;
				HKC_PlayerData.blizzHonorToday = HKC_PlayerData.blizzHonorToday + points;

				if ( points > 4 ) then
					HKC_AddHistory( "|c00ffffff"..date().."|r: +"..points );

					-- update frame if visible
					if ( HKCFrame:IsVisible() ) then
						HKCFrame_Update();
					end
				end
			end
		end

	elseif (event == "CHAT_MSG_COMBAT_HONOR_GAIN") then
	
		local lastKill, rank, ecp;
		
		HKC_CheckResetToday();

		lastKill, rank, ecp = string.match(arg1, HKC_HONORGAIN1);

		-- if not PK
		if ( not lastKill ) then

			-- vehicle?
			lastKill, ecp = string.match(arg1, HKC_HONORGAIN3);
			if ( lastKill ) then
				ecp = tonumber(ecp);
				HKC_KillHonor = HKC_KillHonor + ecp;
				HKC_PlayerData.honorToday = HKC_PlayerData.honorToday + ecp;
				HKC_PlayerData.blizzHonorToday = HKC_PlayerData.blizzHonorToday + ecp;

				if ( HKC_CFG.chatMessagesHK ) then
					DEFAULT_CHAT_FRAME:AddMessage( string.format(HKC_KILLMSG, lastKill, 1, HKC_VEHICLE, ecp) );
				end
				return
			end

			-- bonus honor?
			ecp = string.match(arg1, HKC_HONORGAIN2);
			if ( ecp ) then

				ecp = tonumber(ecp);

				if ( ecp == 0 ) then
					return;
				end

				HKC_PlayerData.honorToday = HKC_PlayerData.honorToday + ecp;
				HKC_PlayerData.blizzHonorToday = HKC_PlayerData.blizzHonorToday + ecp;
				HKC_BonusHonor = HKC_BonusHonor + ecp;

				HKC_AddHistory( "|c00ffffff"..date().."|r: +"..ecp );

				-- update frame if visible
				if ( HKCFrame:IsVisible() ) then
					HKCFrame_Update();
				end

				return
			end

			-- DK?
			lastKill = string.match(arg1, HKC_DISHONOR);
			if ( HKC_CFG.chatMessagesHK and lastKill ) then
				DEFAULT_CHAT_FRAME:AddMessage(HKC_DISHONORWARNING..lastKill..")", 1, 0, 0);

			elseif ( HKC_CFG.chatMessagesHK ) then

				-- Unknown Message
				DEFAULT_CHAT_FRAME:AddMessage(HKC_ERRORMSG..arg1.."'");
			end

			return
		end

		-- add to today's kill history
		if ( not HKC_KillsToday[lastKill] ) then
			-- first kill today
			HKC_KillsToday[lastKill] = 0;
		end
		HKC_KillsToday[lastKill] = HKC_KillsToday[lastKill] + 1;
		
		-- add to lifetime kill history if player is on same server
		if ( not HKC_InBattleground and not lastKill:find("-", 1, true) ) then
			if ( not HKC_KillsLifetime[lastKill] ) then
				HKC_KillsLifetime[lastKill] = 0;
			end
			HKC_KillsLifetime[lastKill] = HKC_KillsLifetime[lastKill] + 1;
		end		

		if ( ecp ) then
			ecp = tonumber(ecp);

			-- honor before diminishing returns
			HKC_PlayerData.blizzHonorToday = HKC_PlayerData.blizzHonorToday + ecp;
			
			
			if ( HKC_KillsToday[lastKill] > 10 ) then
				ecp = 0;
			elseif ( HKC_KillsToday[lastKill] > 1 ) then
				ecp = ecp - ( (HKC_KillsToday[lastKill] - 1) / 10 * ecp );
			end
			
			--[[
			if ( HKC_KillsToday[lastKill] > 4 ) then
				ecp = 0;
			elseif ( HKC_KillsToday[lastKill] > 1 ) then
				ecp = ecp - ( (HKC_KillsToday[lastKill] - 1) * 0.25 * ecp );
			end
			]]
			
			-- honor after estimating diminishing returns
			HKC_PlayerData.honorToday = HKC_PlayerData.honorToday + ecp;
			
			HKC_KillHonor = HKC_KillHonor + ecp;

			-- update frame if visible
			if ( HKCFrame:IsVisible() ) then
				HKCFrame_Update();
			end
		end

		if ( HKC_CFG.chatMessagesHK ) then
			DEFAULT_CHAT_FRAME:AddMessage( string.format(HKC_KILLMSG, lastKill, HKC_KillsToday[lastKill], rank, ecp) );
		end

	elseif ( event == "ZONE_CHANGED_NEW_AREA" ) then
		HKC_ZoneInTime = {};
		HKC_GotArenaScores = false;
		
		HKC_CheckResetToday();

		local instance, instanceType = IsInInstance();
		if ( instance and instanceType == "pvp" ) then
			-- we're in a bg

			HKC_isArena = false;
			HKC_Bracket = nil;
			HKC_LastStats = 0;
			HKC_LastScore = 0;
			HKCTimerFrame:Show();

			map = GetZoneText();
			if ( HKC_Debug ) then
				print("ZONE_CHANGED_NEW_AREA inside battleground; map ==", map);
			end
			
			if ( HKC_InBattleground and map ~= HKC_Map ) then
				-- player switched battlegrounds
				HKC_BonusHistoryOnExit();
			end

			HKC_InBattleground = true;
			HKC_Map = map;
			HKC_EnterTime = time();
			HKC_KillHonor = 0;
			HKC_BonusHonor = 0;

			-- bonus history on BG entrance; remove earliest entry if more than 30
			HKC_AddHistory( string.format(HKC_ENTERED, date(), map) );

		else
			-- we're not in a bg

			HKCTimerFrame:Hide();

			-- if we just left a bg
			if ( HKC_InBattleground ) then
				HKC_BonusHistoryOnExit();
			end

			HKC_InBattleground = false;
		end

	elseif ( event == "UPDATE_BATTLEFIELD_SCORE" ) then
		HKC_Winner = GetBattlefieldWinner();
		local instance, instanceType = IsInInstance();
		local now = time();
		HKC_LastScore = now;

		if ( HKC_Debug ) then
			print("HKC: UPDATE_BATTLEFIELD_SCORE; HKC_Winner ==", HKC_Winner);
		end
		
		if ( instance and instanceType == "pvp" ) then
			
			HKC_isArena = false;
			-- get stats no more than once every 5 seconds in case some retarded addon spams RequestBattlefieldScoreData()
			if ( HKC_Winner or HKC_LastStats < (now - 5) ) then
				HKC_GetBGStats();
			end
		elseif ( instance and instanceType == "arena" ) then
			HKC_isArena = true;
			if ( HKC_Winner ) then
				HKC_GetArenaStats();
			end
		end

	elseif (event == "INSPECT_HONOR_UPDATE") then

		-- do not record players if inside a battleground
		local instance, instanceType = IsInInstance();
		if ( instance and instanceType == "pvp" ) then
			return
		end
		if ( HKC_Debug ) then
			if ( HasInspectHonorData() ) then
				--print("HKC: INSPECT_HONOR_UPDATE; HasInspectHonorData() == true");
			else
				--print("HKC: INSPECT_HONOR_UPDATE; HasInspectHonorData() == false");
			end
		end
		if ( not InspectHonorFrame or not InspectHonorFrame:IsVisible() or not HasInspectHonorData() ) then
			if ( HKC_Debug ) then
				--print("HKC: Inspect honor frame not visible or honor data not loaded");
			end
			return;
		end
		if ( InspectNameText:GetText() ~= UnitName("target") ) then
			if ( HKC_Debug ) then
				print("HKC: Target name and inspect frame name mismatch");
			end
			return;
		end

		local sessionHK, sessionDK, yesterdayHK, yesterdayHonor, thisweekHK, thisweekHonor, lastweekHK, lastweekHonor, lastweekStanding, lifetimeHK, lifetimeDK, lifetimeRank = GetInspectHonorData();
		local pvpname, pvprank = GetPVPRankInfo(UnitPVPRank("target"));
		local name = UnitName("target");

		if ( name and lastweekStanding ) then
		
			mapKey = lastweekStanding;
			
			if ( lastweekStanding == 0 ) then
				mapKey = name;
			else
				if ( HKC_Standings[HKC_Server][name] ) then
					HKC_Standings[HKC_Server][name] = nil;
					
					if ( HKC_Debug ) then
						print("HKC: Deleting bugged record for "..UnitName("target"));
					end
				end

			end
			
			if ( HKC_Standings[HKC_Server][mapKey] ) then
				
				local record = HKC_Standings[HKC_Server][mapKey];
				
				if ( record.name ~= name or record.ranktitle ~= pvpname or record.ranknum ~= pvprank
					or record.class ~= UnitClass("target") or record.HKs ~= lastweekHK
					or record.contribution ~= lastweekHonor
					or math.floor(record.progress * 1000) ~= math.floor(GetInspectPVPRankProgress() * 1000)
				) then
				
					if ( HKC_Debug ) then
						print("previous data:", record.name, record.ranktitle, record.ranknum, record.class, record.HKs, record.contribution, record.progress);
					end

					record.name = name;
					record.ranktitle = pvpname;
					record.ranknum = pvprank;
					record.class = UnitClass("target");
					record.HKs = lastweekHK;
					record.contribution = lastweekHonor;
					record.progress = GetInspectPVPRankProgress();

					if ( HKC_Debug ) then
						print("new data is:", record.name, record.ranktitle, record.ranknum, record.class, record.HKs, record.contribution, record.progress);
					end
					
					DEFAULT_CHAT_FRAME:AddMessage("HKC: Updating PvP data mismatch.  Standing is "..lastweekStanding.." with "..lastweekHonor.." honor");
				end
			else
				HKC_Standings[HKC_Server][mapKey] = {
					name = name,
					ranktitle = pvpname,
					ranknum = pvprank,
					class = UnitClass("target"),
					HKs = lastweekHK,
					contribution = lastweekHonor,
					progress = GetInspectPVPRankProgress(),
				};
				HKC_ServerData[HKC_Server].lastInspectDay = date("*t").yday;
				
				DEFAULT_CHAT_FRAME:AddMessage(name.." added to HKC standings; Standing is "..lastweekStanding.." with "..lastweekHonor.." honor");
			end
		end

	elseif ( event == "PLAYER_LOGIN" ) then
		HKCLogin();
		HKC_LoginDelay = time() + 3;
		HKCTimer2Frame:Show();	-- get player PvP data after a delay otherwise it could return 0s
		
	elseif ( event == "CHAT_MSG_RAID_BOSS_EMOTE" ) then
		if ( HKC_InBattleground ) then
			RequestBattlefieldScoreData();
		end
	end
end

function HKC_GetBGStats()
	local i;
	local a = 0;
	local h = 0;
	local serverPop = { [0] = {}, [1] = {} };
	local players = {};
	local numScores = GetNumBattlefieldScores();
	local name, faction, server, damage, healing, killingBlows, honorGained;
	local hordeCaptures, allianceCaptures = 0, 0;
	local totalKBs = 0;

	HKC_AFKA = 0;
	HKC_AFKH = 0;

	if (numScores > 0) then
		HKC_LastStats = time();

		-- in case UI reloaded
		if ( not HKC_InBattleground ) then
			-- get map name
			local n, instanceId, map;
			for n=1, MAX_BATTLEFIELD_QUEUES do
				_, map, instanceId = GetBattlefieldStatus(n);
				if ( instanceId ~= 0 ) then
					break;
				end
			end

			HKC_InBattleground = true;
			HKC_Map = map;
			HKC_EnterTime = time();
			HKCTimerFrame:Show();
		end

		for i = 1, numScores do

			--name, killingBlows, _, _, honorGained, faction, _, _, _, damage, healing = GetBattlefieldScore(i);
			name, killingBlows, honorableKills, deaths, honorGained, faction = GetBattlefieldScore(i);

			if ( name ) then

				totalKBs = totalKBs + killingBlows;
				
				-- server populations
				if (string.find(name, "-", 1, true)) then
					server = string.sub(name, string.find(name, "-", 1, true) + 1);
				else
					server = HKC_Server;
				end

				if (not serverPop[faction][server]) then
					serverPop[faction][server] = 1;
				else
					serverPop[faction][server] = serverPop[faction][server] + 1;
				end

				-- keep track of when they zoned in (or when first seen at least)
				local now = time();
				if ( not HKC_ZoneInTime[name] ) then
					HKC_ZoneInTime[name] = now;
				end
				if ( faction == 0 ) then
					h = h + 1;

					-- 0 damage, 0 healing, and been in the zone for 5+ mins == afker
					--if ( damage == 0 and healing == 0 and HKC_ZoneInTime[name] < (now - 300) ) then
					--	HKC_AFKH = HKC_AFKH + 1;
					--end
					
					hordeCaptures = hordeCaptures + (GetBattlefieldStatData(i, 1) or 0);
					
				elseif ( faction == 1 ) then
					a = a + 1;
					--if ( damage == 0 and healing == 0 and HKC_ZoneInTime[name] < (now - 300) ) then
					--	HKC_AFKA = HKC_AFKA + 1;
					--end
					
					allianceCaptures = allianceCaptures + (GetBattlefieldStatData(i, 1) or 0);
				end

				if ( name == HKC_PlayerName ) then
					HKC_KBs = killingBlows;
					HKC_Deaths = deaths;
					--HKC_Dmg = damage;
					--HKC_Healing = healing;
					HKC_ScoreboardBonusHonor = honorGained;
				end

				table.insert(players, {
					name = name,
					kbs = killingBlows,
					--damage = damage,
					--healing = healing,
					deaths = deaths,
				});				
			end
		end -- for i = 1, numScores do

		 -- 0 == waiting for first update battlefield score; 1 == not joined late; 2 == joined late
		if ( HKC_JoinedLate == 0 ) then
			if ( totalKBs > 0 ) then
				HKC_JoinedLate = 2;
			else
				HKC_JoinedLate = 1;
			end
			if ( HKC_Debug ) then
				print("HKC: Joined late", HKC_JoinedLate);
			end
		end

		-- KB place
		if ( HKC_KBs > 0 ) then
			table.sort(players, 
				function(a, b)
					return a.kbs > b.kbs;
				end
			);
			for i in ipairs(players) do
				if ( players[i].name == HKC_PlayerName ) then
					HKC_KBPlace = i;
					break;
				end
			end

			-- in case of tie, rank will match that of highest rank
			for i in ipairs(players) do
				if ( players[i].kbs == HKC_KBs ) then
					HKC_KBPlace = i;
					break;
				end
			end
		end

		-- damage place
		--[[
		if ( HKC_Dmg > 0 ) then
			table.sort(players, 
				function(a, b)
					return a.damage > b.damage;
				end
			);
			for i in ipairs(players) do
				if ( players[i].name == HKC_PlayerName ) then
					HKC_DamagePlace = i;
					break;
				end
			end
		end
		]]
		-- healing place
		--[[
		if ( HKC_Healing > 0 ) then
			table.sort(players, 
				function(a, b)
					return a.healing > b.healing;
				end
			);
			for i in ipairs(players) do
				if ( players[i].name == HKC_PlayerName ) then
					HKC_HealingPlace = i;
					break;
				end
			end
		end
		]]
		-- keep track of which side has the most people to determine which bracket range to use.
		-- this is a safety measure in case GetBattlefieldStatus() reports 0 0, or HKC_ALTERAC_VALLEY
		-- isn't localized or a new BG with 30+ people is implemened in the future (I'm assuming it
		-- would use the same level range as AV)
		if ( a > h ) then
			HKC_Participants = a;
		else
			HKC_Participants = h;
		end
		-- debug
		if ( HKC_Debug ) then
			--print("Participants;  Alliance: "..a.."    Horde: "..h);
		end

		HKC_Bracket = HKC_GetBracket(UnitLevel("player"), HKC_Map, HKC_Participants)
			
		if ( HKC_Debug ) then
			--print("HKC: bracket ==", HKC_Bracket);
		end

		local pct;

		-- horde
		HKC_PremadePctH = 0;
		for faction, server in pairs(serverPop[0]) do

			-- if more than 8 people,
			-- and this server comprises of more than or equal to 20% of the faction,
			-- and more than 2 people from this server
			if ( h > 8 and server >= (h * .2) and server > 2 ) then

				-- percent of the people in the faction from this server
				pct = 100 / h * server;
				HKC_PremadePctH = HKC_PremadePctH + pct - ((100 - pct) * .1);	-- reduce the impact of smaller premades on the total
			end
		end
		HKC_PremadePctH = math.floor(HKC_PremadePctH);

		-- alliance
		HKC_PremadePctA = 0;
		for faction, server in pairs(serverPop[1]) do

			-- if more than 8 people,
			-- and this server comprises of more than or equal to 20% of the faction,
			-- and more than 2 people from this server
			if ( a > 8 and server >= (a * .2) and server > 2 ) then

				-- percent of the people in the faction from this server
				pct = 100 / a * server;
				HKC_PremadePctA = HKC_PremadePctA + pct - ((100 - pct) * .1);	-- reduce the impact of smaller premades on the total
			end
		end
		HKC_PremadePctA = math.floor(HKC_PremadePctA);
		
		if ( HKC_Debug ) then
			print("HKC: Captures horde/alliance:", hordeCaptures, allianceCaptures);
		end
		
		if ( HKC_Map == HKC_WARSONG ) then
			HKC_AllianceScore = allianceCaptures;
			HKC_HordeScore = hordeCaptures;
			
		elseif ( HKC_Map ~= HKC_ALTERAC_VALLEY ) then
		
			-- Arathi Basin widgets
			local w1 = C_UIWidgetManager.GetIconAndTextWidgetVisualizationInfo(1893);
			local w2 = C_UIWidgetManager.GetIconAndTextWidgetVisualizationInfo(1894);
			
			if ( w1 and w2 ) then
				HKC_AllianceScore = tonumber(string.match(w1.text, '(%d+)/2000')) or -1;
				HKC_HordeScore = tonumber(string.match(w2.text, '(%d+)/2000')) or -1;
			end
		end
		--[[
		-- get resources, reinforcements, flag captures, victory points
		for i = 1, GetNumWorldStateUI() do
			local _, state, text, icon, _, tooltip = GetWorldStateUIInfo(i);
			if ( icon == "Interface\\TargetingFrame\\UI-PVP-Alliance" ) then
				damage = string.match(text, "(%d+)/%d+");		-- basin/eots
				if ( not damage ) then
					damage = string.match(text, "(%d+)");		-- av
				end
				if ( damage ) then
					HKC_AllianceScore = tonumber(damage);
				end
			end
			if ( icon == "Interface\\TargetingFrame\\UI-PVP-Horde" ) then
				damage = string.match(text, "(%d+)/%d+");		-- basin/eots
				if ( not damage ) then
					damage = string.match(text, "(%d+)");		-- av
				end
				if ( damage ) then
					HKC_HordeScore = tonumber(damage);
				end
			end
			if ( tooltip == "Round ends after this duration" and state == 1 ) then		-- if state == 1, then that side is attacking
				damage, server = string.match(text, "End of Round: (%d+):(%d+)");
				if ( damage ) then
					damage = damage * 60 + server;
				end
				if ( i <= 4 ) then
					-- alliance
					HKC_AllianceScore = 600 - damage;
					--print("Alliance elapsed time: "..HKC_AllianceScore);
				else
					-- horde

					-- If horde score is -1, then this should be the score immediately after the first round ends.
					-- The horde number value at that time should be the amount of time the Alliance had left
					-- when the first round ended
					if ( HKC_HordeScore == -1 ) then

						-- convert time remaining into time elapsed
						damage = 600 - damage;

						-- this value should be more accurate, use it if it seems sane
						if ( damage > HKC_AllianceScore and damage < (HKC_AllianceScore + 25) ) then
							HKC_AllianceScore = damage;
							--print("using more accurate score for alliance: "..HKC_AllianceScore);
						end
					end
					HKC_HordeScore = HKC_AllianceScore - damage;
					--print("Horde elapsed time: "..HKC_HordeScore);
				end
			end
		end
		]]
		
	end  -- if ( numScores > 0 )
end

function HKCLookupHostile(target)
	local char;

	-- force to lowercase then upper the 1st letter
	target = string.lower(target);
	char = string.sub(target, 1, 1);
	target = string.sub(target, 2);
	target = string.upper(char)..target;
	
	local s1 = "";
	local s2 = "";
	
	if ( HKC_KillsToday[target] ) then
		s1 = target.." "..HKC_KILLSTODAYTEXT..": "..HKC_KillsToday[target];
	else
		s1 = HKC_NEVERKILLED;
	end
	if ( HKC_KillsLifetime[target] ) then
		s2 = "  Lifetime kills: "..HKC_KillsLifetime[target].." ";
	end
	
	DEFAULT_CHAT_FRAME:AddMessage(s1..s2);
end

function HKCLookupFriendly(target)
	local char;

	-- force to lowercase then upper the 1st letter
	target = string.lower(target);
	char = string.sub(target, 1, 1);
	target = string.sub(target, 2);
	target = string.upper(char)..target;
	
	local standing = 0;
	local found = false;
	
	for k, r in pairs(HKC_Standings[HKC_Server]) do
		if ( r.name == target ) then
			if ( tonumber(k) ) then
				standing = k;
			end
			s1 = (r.ranktitle or "<unranked>").." "..r.name.." - Standing: "..standing.." Rank: "..((r.ranknum + r.progress) - r.progress % 0.001).." Honor: "..r.contribution;
			DEFAULT_CHAT_FRAME:AddMessage(s1);
			found = true;
			break;
		end		
	end
	standing = 0;
	for k, r in pairs(HKC_WBLStandings[HKC_Server]) do
		if ( r.name == target ) then
			if ( tonumber(k) ) then
				standing = k;
			end
			s2 = "Last Week Standing: "..standing.." "..(r.ranktitle or "<unranked>").." Rank: "..((r.ranknum + r.progress) - r.progress % 0.001).." Honor: "..r.contribution;
			DEFAULT_CHAT_FRAME:AddMessage(s2);
			found = true;
			break;
		end		
	end
	
	return found;
end

function HKCCmdLine(param)
	local arg1;
	local arg2;
	_, _, arg1, arg2 = string.find(param, "(%a+)%s+(.+)");
	if (not arg1) then
		arg1 = param;
	end

	if (arg1 == "lookup") then
		local hostile = 2; -- 2 signifies unknown; need to check both if unknown
		if (not arg2 and UnitExists("target") and UnitIsPlayer("target") ) then
			arg2 = UnitName("target");
			hostile = UnitIsEnemy("target", "player"); -- returns '1' for hostile, else nil
		end
		if (arg2) then
			local found;
			if ( not hostile or hostile == 2 ) then
				found = HKCLookupFriendly(arg2);
			end
			if ( hostile and not found ) then
				HKCLookupHostile(arg2);
			end
		end

	elseif (arg1 == "honor") then
		DEFAULT_CHAT_FRAME:AddMessage( HKC_HKCTODAYEST.." |c00ffff00"..HKC_PlayerData.honorToday.."|r" );
		DEFAULT_CHAT_FRAME:AddMessage( HKC_BEFOREDIMINISHING.." |c00ffff00"..HKC_PlayerData.blizzHonorToday.."|r" );
		
		-- if in a BG, show honor gained so far
		if (HKC_InBattleground) then
			DEFAULT_CHAT_FRAME:AddMessage( HKC_KILLHONOR.." |c00ffff00"..math.floor(HKC_KillHonor).."|r" );
			DEFAULT_CHAT_FRAME:AddMessage( HKC_BONUSHONOR.." |c00ffff00"..math.floor(HKC_BonusHonor).."|r" );
			DEFAULT_CHAT_FRAME:AddMessage( HKC_FROMBG.." |c00ffff00"..math.floor(HKC_BonusHonor + HKC_KillHonor).."|r" );
		end

	elseif (arg1 == "show") then
		HKCOpenFrame(nil, true);
		
	elseif (arg1 == "info") then
		HKCInfo();
		
	elseif (arg1 == "debug") then
		if ( HKC_Debug ) then
			HKC_Debug = false;
			DEFAULT_CHAT_FRAME:AddMessage("HKC: Debug messages off");
		else
			HKC_Debug = true;
			DEFAULT_CHAT_FRAME:AddMessage("HKC: Debug messages on");
		end
		
	elseif (arg1 == "rank") then
		HKCRank(arg2);

	elseif (arg1 == "standings") then
		HKCStandings(arg2);

	elseif (arg1 == "lastweek") then
		HKCLastWeekStandings(arg2);

	elseif (arg1 == "zeroed") then
		HKCZeroed();
		
	elseif (arg1 == "delete") then
		if ( arg2 ) then
			if ( tonumber(arg2) ) then
				arg2 = tonumber(arg2);
			end
			if ( HKC_Standings[HKC_Server][arg2] ) then
				DEFAULT_CHAT_FRAME:AddMessage((HKC_Standings[HKC_Server][arg2].name or "(nil)").." deleted from standings data.");
				HKC_Standings[HKC_Server][arg2] = nil;
			else
				DEFAULT_CHAT_FRAME:AddMessage("Standing record not found");
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("Specify a standing # or player name if standing is 0");
		end

	elseif (arg1 == "forcereset") then
	
		if (arg2 == "day") then
			HKC_CheckResetToday(true);
			
		elseif (arg2 == "week") then
			HKC_CheckResetThisWeek(true);
		else
			DEFAULT_CHAT_FRAME:AddMessage(HKC_FORCERESET_SYNTAX, 1, 1, 0);
		end
		
	elseif (arg1 == "plot") then
		HKCPlot(arg2);

	else
		local s;
		for _, s in ipairs(HKC_HELP) do
			DEFAULT_CHAT_FRAME:AddMessage(s);
		end
	end
end

-- if text is true, then return values as text display strings, i.e. "(#1)" instead of 1
function HKC_SplitItem13(i, text)
	local kbs, damage, healing, joinedLate;

	kbs = i % 100;
	damage = ((i % 10000) - kbs) / 100;
	healing = ((i % 1000000) - i % 10000) / 10000;

	joinedLate = ((i % 10000000) - i % 1000000) / 1000000;
	if ( joinedLate == 1 ) then
		joinedLate = true;
	else
		joinedLate = false;
	end

	if ( text ) then
		if ( kbs > 0 ) then
			kbs = "(#"..kbs..")";
		else
			kbs = "";
		end
		if ( damage > 0 ) then
			damage = "(#"..damage..")";
		else
			damage = "";
		end
		if ( healing > 0 ) then
			healing = "(#"..healing..")";
		else
			healing = "";
		end
		if ( joinedLate ) then
			joinedLate = HKC_JOINED_LATE;
		else
			joinedLate = "";
		end
	end

	return kbs, damage, healing, joinedLate;
end

function HKC_ShowRecord(record)

	local text = "|c00ffffff"..date("%D %T", record[1]).."|r: ";
	local kbRank, damageRank, healingRank, joinedLate = "", "", "", "";

	if ( record[10] ) then
		kbRank, damageRank, healingRank, joinedLate = HKC_SplitItem13(record[10], true);
	end

	if ( record[2] == 0 ) then
		text = text..HKC_HORDE..HKC_WON;
	elseif ( record[2] == 1 ) then
		text = text..HKC_ALLIANCE..HKC_WON;
	else
		text = text..HKC_LEFT_EARLY;
	end
	table.insert( HKC_FrameText, string.format(text, date("%c", record[1])) );

	text = HKC_ELAPSED..": |c0000ffff%i|rm; %s  "..HONOR.." "..HKC_GAINED..": |c0000ffff%i|r";
	table.insert( HKC_FrameText, string.format(text, record[4], joinedLate, record[3] ) );

	if ( record[11] and record[11] >= 0 ) then
		text = HKC_ALLIANCE.." "..HKC_SCORE..": |c00ffffff"..record[11].."|r; ";
		text = text..HKC_HORDE.." "..HKC_SCORE..": |c00ffffff"..record[12].."|r ";
		table.insert( HKC_FrameText, text );
	end
	
	if ( record[5] > 0 ) then
		table.insert( HKC_FrameText, string.format(HKC_ALLIANCE..HKC_PREMADE_SCORE.."|c00ffffff%i|r", record[5]) );
	end
	if ( record[6] > 0 ) then
		table.insert( HKC_FrameText, string.format(HKC_HORDE..HKC_PREMADE_SCORE.."|c00ffffff%i|r", record[6]) );
	end
	--[[
	if ( record[7] > 0 ) then
		table.insert( HKC_FrameText, string.format(HKC_ALLIANCE..HKC_AFKERS.."|c00ffffff%i|r", record[7]) );
	end
	if ( record[8] > 0 ) then
		table.insert( HKC_FrameText, string.format(HKC_HORDE..HKC_AFKERS.."|c00ffffff%i|r", record[8]) );
	end
	]]

	text = HKC_KBS..": |c00ffff00%i|r %s  "..HKC_DEATHS..": |c00ffff00%i|r";
	table.insert(HKC_FrameText, string.format(text, record[7], kbRank, record[8]) );
	--text = DAMAGE..": |c00ffff00%i|r; %s  "..HKC_HEALING..": |c00ffff00%i|r %s";
	--table.insert(HKC_FrameText, string.format(text, record[10], damageRank, record[11], healingRank) );

	if ( record[9] ~= HKC_PlayerName ) then
		table.insert(HKC_FrameText, string.format(CHARACTER..": |c0000ff00%s|r", record[9]));
	end
	table.insert(HKC_FrameText, "");
end

function HKC_GetWinPercentiles(aWins, hWins, incompletes)
	if ( aWins + hWins + incompletes == 0 ) then
		return 0, 0, 0;
	end
	local total = aWins + hWins + incompletes;

	-- ghetto rounding
	local aPct = 100 / total * aWins;
	if ( (aPct % 1) >= .5 ) then
		aPct = math.ceil(aPct);
	else
		aPct = math.floor(aPct);
	end
	local hPct = 100 / total * hWins;
	if ( (hPct % 1) >= .5 ) then
		hPct = math.ceil(hPct);
	else
		hPct = math.floor(hPct);
	end
	local incompletePct = 100 / total * incompletes;
	if ( (incompletePct % 1) >= .5 ) then
		incompletePct = math.ceil(incompletePct);
	else
		incompletePct = math.floor(incompletePct);
	end

	return aPct, hPct, incompletePct;
end

function HKCFrameBGStats(bg, bracket)

	HKC_FrameText = {};

--	table.insert( HKC_FrameText, "" );
	table.insert( HKC_FrameText, string.format("|c00ffffff%s|r [|c00ffffff%s|r]", bg, bracket) );
	table.insert( HKC_FrameText, "" );


	-- lifetime win/losses (independant of record data)

	local i, horde, alliance, left = 0, 0, 0, 0;
	local data, aPct, hPct, iPct, aPct2, hPct2;

	-- get total wins/losses
	for _, data in pairs(HKC_TotalWinLoss[HKC_Server][bg][bracket]) do
		horde = horde + data[1];
		alliance = alliance + data[2];
		left = left + data[3];
	end

	-- "Horde Wins: n (x%/y%)"
	local sH = string.format(VICTORY_TEXT_ARENA_WINS, HKC_HORDE)..": |c0000ffff%i|r (|c00ff1919%i%%|r/|c00ff1919%i%%|r)";
	local sA = string.format(VICTORY_TEXT_ARENA_WINS, HKC_ALLIANCE)..": |c0000ffff%i|r (|c0000adef%i%%|r/|c0000adef%i%%|r)";

	-- this player only's wins/losses
	if ( HKC_TotalWinLoss[HKC_Server][bg][bracket][HKC_PlayerName] ) then
		data = HKC_TotalWinLoss[HKC_Server][bg][bracket][HKC_PlayerName];

		aPct, hPct, iPct = HKC_GetWinPercentiles(data[2], data[1], data[3]);
		aPct2, hPct2 = HKC_GetWinPercentiles(data[2], data[1], 0);

		table.insert( HKC_FrameText, "|c0000ff00"..HKC_PlayerName.."|r's "..HKC_MATCHES );
		table.insert( HKC_FrameText, string.format(sA, data[2], aPct, aPct2) );
		table.insert( HKC_FrameText, string.format(sH, data[1], hPct, hPct2) );
		table.insert( HKC_FrameText, "|c00999999"..HKC_LEFT_EARLY.."|r: |c0000ffff"..data[3].."|r (|c00999999"..iPct.."%|r)" );
		table.insert( HKC_FrameText, "" );
	end

	-- all wins/losses
	aPct, hPct, iPct = HKC_GetWinPercentiles(alliance, horde, left);
	aPct2, hPct2 = HKC_GetWinPercentiles(alliance, horde, 0);

	table.insert( HKC_FrameText, ALL.." "..HKC_MATCHES );
	table.insert( HKC_FrameText, string.format(sA, alliance, aPct, aPct2) );
	table.insert( HKC_FrameText, string.format(sH, horde, hPct, hPct2) );
	table.insert( HKC_FrameText, "|c00999999"..HKC_LEFT_EARLY.."|r: |c0000ffff"..left.."|r (|c00999999"..iPct.."%|r)" );
	table.insert( HKC_FrameText, "" );


	-- display record data

	local records, cap;
	local count = 0;
	records = table.getn(HKC_BGHistory[HKC_Server][bg][bracket]);

	if ( records > 50 ) then
		cap = 50;
	else
		cap = records;
	end
	table.insert( HKC_FrameText, string.format(HKC_LAST_50, records, cap) );
	table.insert( HKC_FrameText, "" );

	for i = records, 1, -1 do
		HKC_ShowRecord(HKC_BGHistory[HKC_Server][bg][bracket][i]);
		count = count + 1;
		if ( count >= 50 ) then
			break;
		end
	end
end

function HKCFrameHistory()
	local v;

	HKC_FrameText = {};
	for _, v in ipairs(HKC_BonusHistory) do
		table.insert(HKC_FrameText, v);
	end
end

-- t = HKC_KillsToday or HKC_KillsLifetime
-- returns descending sorted indexed table of tables: { kills = #, names = { "player1", "player2", "etc" } }
function HKCGetTopX(t, x)
	local results = {};

	if ( not t or not x ) then
		return results;
	end
	
	local names = {};
	local killTotals = {};
	
	for name, kills in pairs(t) do
		if ( not names[kills] ) then
			table.insert(killTotals, kills);
			names[kills] = {};
		end
		
		table.insert(names[kills], name);
	end
	
	table.sort(killTotals, function(a, b) return a > b;	end);

	local count = 0;
	for _, kills in ipairs(killTotals) do

		table.insert(results, { kills = kills, names = names[kills] });
		count = count + #names[kills];
		if ( count >= x ) then
			break;
		end
	end
	
	return results;
end

-- t = result from HKCGetTopX()
function HKCTopXFrameOutput(t)
	local s;
	
	for i, t2 in ipairs(t) do
		s = "";
		
		if ( #t2.names == 1 ) then
			s = t2.names[1].." ("..t2.kills..")";
		else
			for j, name in ipairs(t2.names) do
			
				if ( (#s + #name) > 48 ) then
					table.insert(HKC_FrameText, s);
					s = "";
				end
				s = s..name..", ";
			end			
			s = s:sub(1, -3); -- cut off last comma
			s = s.." ("..t2.kills..")";
		end
		table.insert(HKC_FrameText, s);
	end
end

function HKCFrameTop()
	local name, kills, count, lastkills, rank, victim, count;
	local top10 = {};
	local targetarr;
	local output = "";

	HKC_FrameText = {};

	-- people killed today
	count = 0;
	for _ in pairs(HKC_KillsToday) do
		count = count + 1;
	end
	table.insert(HKC_FrameText, string.format(HKC_PEOPLEKILLEDTODAY, count) );

	-- people killed lifetime
	count = 0;
	for _ in pairs(HKC_KillsLifetime) do
		count = count + 1;
	end
	table.insert(HKC_FrameText, string.format(HKC_PEOPLEKILLEDLIFETIME, count, HKC_Server) );

	-- number of people who no longer give contribution for today
	count = 0;
	for _, kills in pairs(HKC_KillsToday) do
		if (kills > 3) then
			count = count + 1;
		end
	end
	table.insert(HKC_FrameText, string.format(HKC_SUMNOHONOR, count) );
	table.insert(HKC_FrameText, "");

	table.insert(HKC_FrameText, "|c00ffffff"..HKC_TOP10TODAY.."|r");
	HKCTopXFrameOutput(HKCGetTopX(HKC_KillsToday, 10));
	
	table.insert(HKC_FrameText, "");
	
	table.insert(HKC_FrameText, "|c00ffffff"..HKC_TOP10TOTAL.."|r");
	HKCTopXFrameOutput(HKCGetTopX(HKC_KillsLifetime, 10));
end

-- main drop down

function HKCFrameDropDown_Initialize()
	local k, v, info;

	for k, v in ipairs(HKC_DROPDOWN_LABELS) do
		UIDropDownMenu_AddButton( {
			text = v,
			value = k,
			func = HKCFrameDropDown_OnClick,
		} );
	end
end

function HKCFrameDropDown_OnClick(self)
	local value, k;

	-- hide config widgets
	for k in ipairs(HKC_CONFIG_OPTIONS) do
		_G["HKCOption"..k.."CheckButton"]:Hide();
	end

	HKCMaxRecordsEditBox:Hide();
	HKCMaxArenaRecordsEditBox:Hide();
	HKCResetHourEditBox:Hide();

	-- hide BG history drop downs and table button
	HKCBGHistoryDropDown:Hide();
	HKCBGHistoryBracketDropDown:Hide();
	HKCFrameTableButton:Hide();
	HKCArenaHistoryDropDown:Hide();

	UIDropDownMenu_SetSelectedID( HKCFrameDropDown, self.value );
	value = UIDropDownMenu_GetSelectedID( HKCFrameDropDown );

	if ( value ) then
		HKC_Selected = value;
	end

	if ( HKC_Selected == 2 ) then

		-- Bonus History

		HKCFrameHistory();
		HKCFrame_Update();	-- needed to get the scroll bar slider to end up at the bottom every time
		if ( #HKC_FrameText == HKC_MAX_HISTORY ) then
			HKCScrollFrameScrollBar:SetValue(936);
		end

	elseif ( HKC_Selected == 3 ) then

		-- Kills

		HKCFrameTop();

	elseif ( HKC_Selected == 4 ) then

		-- Standings

		HKCStandingsGUI();

	elseif ( HKC_Selected == 5 ) then

		-- Arena History

		HKC_FrameText = {};
		HKCArenaHistoryDropDown:Show();

		UIDropDownMenu_SetWidth( HKCArenaHistoryDropDown, 50 );
		UIDropDownMenu_Initialize( HKCArenaHistoryDropDown, HKCArenaHistoryDropDown_Initialize );
		if ( HKC_LastArenaSize ) then
			UIDropDownMenu_SetSelectedValue( HKCArenaHistoryDropDown, HKC_LastArenaSize );
			HKCFrameArenaHistory(HKC_LastArenaSize);
		end

	elseif ( HKC_Selected == 6 ) then

		-- Config

		HKC_FrameText = {};

		for k in ipairs(HKC_CONFIG_OPTIONS) do
			_G["HKCOption"..k.."CheckButton"]:Show();
		end
		HKCMaxRecordsEditBox:Show();
		HKCMaxArenaRecordsEditBox:Show();
		HKCResetHourEditBox:Show();
	else

		-- BG Statistics

		HKCBGHistoryDropDown:Show();
		HKCBGHistoryBracketDropDown:Show();
		HKCFrameTableButton:Show();

		HKCScrollFrameScrollBar:SetValue(0);

		local bg;

		-- set BG drop down labels
		HKC_BGHISTORY_LABELS = {};
		for k in pairs(HKC_BGHistory[HKC_Server]) do
			table.insert(HKC_BGHISTORY_LABELS, k);
		end

		-- select BG
		if ( HKC_BGHISTORY_LABELS[HKC_BGHistory_Selected] ) then
			bg = HKC_BGHISTORY_LABELS[HKC_BGHistory_Selected];

		elseif ( HKC_BGHISTORY_LABELS[1] ) then

			HKC_BGHistory_Selected = 1;
			bg = HKC_BGHISTORY_LABELS[HKC_BGHistory_Selected];
		end

		UIDropDownMenu_SetWidth( HKCBGHistoryDropDown, 120 );
		UIDropDownMenu_SetWidth( HKCBGHistoryBracketDropDown, 75 );

		if ( bg ) then
			HKC_SetBracketLabels(bg);
			HKC_SetToHighestBracket();

			UIDropDownMenu_Initialize( HKCBGHistoryDropDown, HKCBGHistoryDropDown_Initialize );
			UIDropDownMenu_SetSelectedID( HKCBGHistoryDropDown, HKC_BGHistory_Selected );

			UIDropDownMenu_Initialize( HKCBGHistoryBracketDropDown, HKCBGHistoryBracketDropDown_Initialize );
			UIDropDownMenu_SetSelectedID( HKCBGHistoryBracketDropDown, HKC_BGHistoryBracket_Selected );

			HKC_ShowHistory();
		else
			HKC_FrameText = {};
		end

	end
	HKCFrame_Update();
end

function HKC_ShowHistory(highestBracket)
	local k, bg, bracket;
	bg = HKC_BGHISTORY_LABELS[HKC_BGHistory_Selected];

	if ( not HKC_BGHistory[HKC_Server] ) then
		print("HKC Error: HKC_BGHistory[HKC_Server] == null");
		return
	end

	if ( HKC_BGHistory[HKC_Server][bg] ) then

		HKC_SetBracketLabels(bg);

		if ( highestBracket ) then
			HKC_SetToHighestBracket();
		end

		HKCBGHistoryBracketDropDown_Initialize();

		-- use selected bracket
		if ( HKC_BGHISTORY_BRACKET_LABELS and HKC_BGHISTORY_BRACKET_LABELS[HKC_BGHistoryBracket_Selected] ) then
			bracket = HKC_BGHISTORY_BRACKET_LABELS[HKC_BGHistoryBracket_Selected];
			UIDropDownMenu_SetSelectedID( HKCBGHistoryBracketDropDown, HKC_BGHistoryBracket_Selected );

		elseif ( HKC_BGHISTORY_BRACKET_LABELS[1] ) then
			bracket = HKC_BGHISTORY_BRACKET_LABELS[1];
			UIDropDownMenu_SetSelectedID( HKCBGHistoryBracketDropDown, 1 );
			HKC_BGHistoryBracket_Selected = 1;
		else
			-- if no selected bracket or other error, just pick one
			for k in pairs(HKC_BGHistory[HKC_Server][bg]) do
				bracket = k;
				break;
			end
		end

		-- drop downs are buggy, and display incorrect text
		UIDropDownMenu_SetText(HKCBGHistoryBracketDropDown, HKC_BGHISTORY_BRACKET_LABELS[HKC_BGHistoryBracket_Selected]);

		if ( bracket ) then
			HKCFrameBGStats(bg, bracket);
		end
	end
end

-- BG history drop down

function HKCBGHistoryDropDown_Initialize()
	local k, v, info;

	for k, v in ipairs(HKC_BGHISTORY_LABELS) do
		UIDropDownMenu_AddButton( {
			text = v,
			value = k,
			func = HKCBGHistoryDropDown_OnClick,
		} );
	end

end

function HKCBGHistoryDropDown_OnClick(self)

	UIDropDownMenu_SetSelectedID( HKCBGHistoryDropDown, self.value );
	value = UIDropDownMenu_GetSelectedID( HKCBGHistoryDropDown );

	if ( value ) then
		HKC_BGHistory_Selected = value;
	end

	HKC_ShowHistory(true);
	HKCFrame_Update();
end

-- BG history bracket drop down

function HKCBGHistoryBracketDropDown_Initialize()
	local k, v, bg;

	for k, v in ipairs(HKC_BGHISTORY_BRACKET_LABELS) do
		UIDropDownMenu_AddButton( {
			text = v,
			value = k,
			func = HKCBGHistoryBracketDropDown_OnClick,
		} );
	end

end

function HKCBGHistoryBracketDropDown_OnClick(self)

	UIDropDownMenu_SetSelectedID( HKCBGHistoryBracketDropDown, self.value );
	value = UIDropDownMenu_GetSelectedID( HKCBGHistoryBracketDropDown );

	if ( value ) then
		HKC_BGHistoryBracket_Selected = value;
	else
		value = 1;
	end

	HKC_ShowHistory();
	HKCFrame_Update();
end

function HKCFrame_Update()
	local offset = FauxScrollFrame_GetOffset(HKCScrollFrame);
	local items = #HKC_FrameText;
	local i;

	HKCFrameEstHonorPoints:SetText( math.floor(HKC_PlayerData.honorToday) );
	HKCFrameBlizHonorPoints:SetText( HKC_PlayerData.blizzHonorToday );

	-- if in a BG, show honor gained so far
	if (HKC_InBattleground) then
		local gained = math.floor(HKC_BonusHonor + HKC_KillHonor);

		--HKCFrameKillHonorLabel:Show();
		--HKCFrameKillHonorPoints:Show();
		--HKCFrameBonusHonorLabel:Show();
		--HKCFrameBonusHonorPoints:Show();
		HKCFrameHonorBGLabel:Show();
		HKCFrameBGHonorPoints:Show();

		--HKCFrameHonorableKillsLabel:Hide();
		--HKCFrameGainedTodayLabel:Hide();
		--HKCFrameHonorableKillsPoints:Hide();
		--HKCFrameGainedTodayPoints:Hide();

		--HKCFrameKillHonorPoints:SetText(HKC_KillHonor);
		--HKCFrameBonusHonorPoints:SetText(HKC_BonusHonor);
		HKCFrameBGHonorPoints:SetText(gained);
	else
		--HKCFrameKillHonorLabel:Hide();
		--HKCFrameKillHonorPoints:Hide();
		--HKCFrameBonusHonorLabel:Hide();
		--HKCFrameBonusHonorPoints:Hide();
		HKCFrameHonorBGLabel:Hide();
		HKCFrameBGHonorPoints:Hide();

		--HKCFrameHonorableKillsLabel:Show();
		--HKCFrameGainedTodayLabel:Show();
		--HKCFrameHonorableKillsPoints:Show();
		--HKCFrameGainedTodayPoints:Show();

		--HKCFrameHonorableKillsPoints:SetText(GetPVPLifetimeStats());
		--HKCFrameGainedTodayPoints:SetText(HKC_PlayerData.honorToday);
	end

	for i = 1, 22 do
		if ( HKC_FrameText[i + offset] ) then
			_G["HKCFrameBody"..i.."Text"]:SetText( HKC_FrameText[i + offset] );
		else
			_G["HKCFrameBody"..i.."Text"]:SetText("");
		end

	end

	if ( items <= 22 ) then
		HKCScrollFrame:Hide();
	else
		HKCScrollFrame:Show();
	end

	FauxScrollFrame_Update(HKCScrollFrame, items, 22, 12 );
end

function HKC_SetBracketLabels(bg)
	-- set bracket drop down labels
	HKC_BGHISTORY_BRACKET_LABELS = {};
	for k in pairs(HKC_BGHistory[HKC_Server][bg]) do
		table.insert(HKC_BGHISTORY_BRACKET_LABELS, k);
	end
end

function HKC_SetToHighestBracket()
	if ( HKC_BGHISTORY_BRACKET_LABELS[1] ) then
		local highestMaxLevel = tonumber(HKC_BGHISTORY_BRACKET_LABELS[1]:sub( HKC_BGHISTORY_BRACKET_LABELS[1]:find("-", 1, true) + 1 ));
		local highestBracket = 1;
		local maxLevel;

		for i, levelRange in pairs(HKC_BGHISTORY_BRACKET_LABELS) do
			maxLevel = tonumber(levelRange:sub( levelRange:find("-", 1, true) + 1 ));

			if ( maxLevel > highestMaxLevel ) then
				highestMaxLevel = maxLevel;
				highestBracket = i;
			end
		end

		HKC_BGHistoryBracket_Selected = highestBracket;
	end
end

function HKCFrame_OnShow(self)
	if ( UnitFactionGroup("player") == "Horde" ) then
		HKCFramePortrait:SetTexture("Interface\\PVPRankBadges\\PvPRankHorde");
	else
		HKCFramePortrait:SetTexture("Interface\\PVPRankBadges\\PvPRankAlliance");
	end
	HKCShowButton:Hide();

	UIDropDownMenu_Initialize( HKCFrameDropDown, HKCFrameDropDown_Initialize );
	UIDropDownMenu_SetWidth( HKCFrameDropDown, 100 );
	UIDropDownMenu_SetSelectedID( HKCFrameDropDown, HKC_Selected );
	HKCFrameDropDown_OnClick(HKCFrameDropDown);
	UIDropDownMenu_SetText( HKCFrameDropDown, HKC_DROPDOWN_LABELS[HKC_Selected] );
end

function HKCCloseFrame()
	HKCFrame:Hide();
	--PlaySound("igCharacterInfoClose");
end

function HKCOpenFrame(self, force)
	if ( HKC_CFG.doNotOpen and not force ) then
		return
	end
	HKCFrame:Show();
	--PlaySound("igCharacterInfoOpen");
end


-- Arena History Functions

function HKC_DisplayArenaRecord(record)

	local text = "|c00ffffff"..date("%c", record[2]).."|r: "..HKC_RATING_CHANGE..": |c0000ffff"..record[3].."|r";
	table.insert( HKC_FrameText, text );

	local teamNum, team;

	for teamNum = 0, 1 do

		team = record[teamNum];

		if ( not team ) then
			break;
		end

		text = "|c00ffffff"..team[1].."|r - "..HKC_RATED.." |c00ffff00"..team[2].."|r";
		table.insert( HKC_FrameText, text );

		if ( team[3] ) then
			text = HKC_SERVER_LABEL..": "..team[3];
			table.insert( HKC_FrameText, text );
		end

		for i = 4, table.getn(team) do
			text = "|c0000ff00"..team[i].name.."|r, "..team[i].race.." "..team[i].class;
			table.insert( HKC_FrameText, text );

			text = "  ";
			if ( team[i].kbs > 0 ) then
				text = text..team[i].kbs.." "..HKC_KBS.."; ";
			end
			if ( team[i].damage > 0 ) then
				text = text..team[i].damage.." "..DAMAGE;
			end
			if ( team[i].healing > 0 ) then
				if ( team[i].damage > 0 ) then
					text = text.."; ";
				end
				text = text..team[i].healing.." "..HKC_HEALING;
			end

			table.insert( HKC_FrameText, text );
		end
	end

	text = TIME_ELAPSED.." |c0000ffff"..SecondsToTime(record[4]).."|r";
	table.insert( HKC_FrameText, text );

	table.insert( HKC_FrameText, "" );
end

function HKCFrameArenaHistory(size)
	HKC_FrameText = {};

	if ( not size ) then
		return
	end

	local i;

	table.insert( HKC_FrameText, "|c00ffffff"..size.."v"..size.."|r:" );
	table.insert( HKC_FrameText, "" );

	for i = table.getn(HKC_ArenaHistory[size]), 1, -1 do
		HKC_DisplayArenaRecord(HKC_ArenaHistory[size][i]);
	end

	table.insert( HKC_FrameText, "" );
	table.insert( HKC_FrameText, "" );
end

function HKC_GetArenaStats()
	if ( HKC_GotArenaScores ) then
		return;
	end

	local teamName, teamRating, newTeamRating, status, id, size;
	local _, isRegistered = IsActiveBattlefieldArena();

	for i = 1, MAX_BATTLEFIELD_QUEUES do
		status, _, id, _, _, size = GetBattlefieldStatus(i);
		if ( status == "active" ) then
			break;
		end
		size = nil;
	end

	if ( not size ) then
		return
	end
	HKC_LastArenaSize = size;

	if ( not isRegistered ) then
		return
	end

	local numScores = GetNumBattlefieldScores();
	local i, name, faction, server, class, race, damage, healing, killingBlows, myTeam, otherTeam;
	local teams = { [0] = {}, [1] = {} };
	teams[0][1] = "";
	teams[1][1] = "";
	teams[0][2] = 0;
	teams[1][2] = 0;

	if ( numScores > 0 ) then
		for i = 1, numScores do

			name, killingBlows, _, _, _, faction, race, class, _, damage, healing = GetBattlefieldScore(i);

			if ( name == HKC_PlayerName ) then
				myTeam = faction;
				if ( faction == 0 ) then
					otherTeam = 1;
				else
					otherTeam = 0;
				end
			end

			if ( string.find(name, "-", 1, true) ) then
				_, _, name, server = string.find(name, "(.+)%-(.+)");
			else
				server = HKC_Server;
			end
			if ( not server ) then
				server = "";
			end

			teams[faction][3] = server;
			table.insert(teams[faction], {
				name = name,
				class = class,
				race = race,
				kbs = killingBlows,
				damage = damage,
				healing = healing
			} );
		end
	end

	if ( #teams[0] < 4 or #teams[1] < 4 ) then
		return
	end

	teamName, teamRating, newTeamRating = GetBattlefieldTeamInfo(otherTeam);

	if ( not teamName or teamRating  == 0 ) then
		return
	end

	teams[otherTeam][1] = teamName;
	teams[otherTeam][2] = teamRating;

	teamName, teamRating, newTeamRating = GetBattlefieldTeamInfo(myTeam);

	if ( not teamName or teamRating == 0 ) then
		return
	end

	teams[myTeam][1] = teamName;
	teams[myTeam][2] = teamRating;

	local record = {
		[0] = teams[0],
		[1] = teams[1],
		[2] = time(date("*t"));
		[3] = (newTeamRating - teamRating),
		[4] = (GetBattlefieldInstanceRunTime() / 1000),
	};

	if ( not HKC_ArenaHistory[size] ) then
		HKC_ArenaHistory[size] = {};
	end

	table.insert(HKC_ArenaHistory[size], record);

	-- remove old records if over the max records limit
	if ( table.getn(HKC_ArenaHistory[size]) > HKC_CFG.maxArenaRecords ) then
		local n = table.getn(HKC_ArenaHistory[size]) - HKC_CFG.maxArenaRecords;

		for i = 1, n do
			table.remove(HKC_ArenaHistory[size], 1);
		end
	end

	HKC_GotArenaScores = true;
end

function HKCArenaHistoryDropDown_Initialize()
	local k;

	for k in pairs(HKC_ArenaHistory) do
		UIDropDownMenu_AddButton( {
			text = k.."v"..k,
			value = k,
			func = HKCArenaHistoryDropDown_OnClick,
		} );

		if ( not HKC_LastArenaSize ) then
			HKC_LastArenaSize = k;
		end
	end

end

function HKCArenaHistoryDropDown_OnClick(self)

	UIDropDownMenu_SetSelectedValue( HKCArenaHistoryDropDown, self.value );
	value = UIDropDownMenu_GetSelectedValue( HKCArenaHistoryDropDown );

	if ( not value ) then
		return
	end

	HKCFrameArenaHistory(value);
	HKC_LastArenaSize = value;
	HKCFrame_Update();
end

function HKCStandings(range)
	local standing, player, smin, smax, wblstanding, wbltext, wblplayer, change;
	local defaultMax = 9999;
	local count = 0;

	if (not range) then
		smin = 1;
		smax = defaultMax;
	else
		_, _, smin, smax = string.find(range, "(%d+)%s*%-%s*(%d+)");
		if (not smin) then
			-- single standing?
			_, _, smin = string.find(range, "^(%d+)$");
			if (smin) then
				smax = smin;
			end
		end
		smin = tonumber(smin);
		smax = tonumber(smax);
		if (not smin or not smax or smax < smin) then
			smin = 1;
			smax = defaultMax;
		end
	end

	DEFAULT_CHAT_FRAME:AddMessage("Currently known "..smin.."-"..smax.." standings for this week:", 1, 1, 0);

	for standing = smin, smax do
	
		if (HKC_Standings[HKC_Server][standing]) then
		
			count = count + 1;
			player = HKC_Standings[HKC_Server][standing];

			wbltext = "";
			-- iterate through week before last standings
			for wblstanding, wblplayer in pairs(HKC_WBLStandings[HKC_Server]) do

				-- if player found in week before last standings array
				if (wblplayer.name == player.name) then
					
					-- get exact change in rank for player
					change = (player.ranknum + player.progress) - (wblplayer.ranknum + wblplayer.progress);
					change = string.format("%.2f", (change));

					wbltext = "; Last Week Rank: "..string.format("%i", (wblplayer.progress * 100)).."% into "..(wblplayer.ranktitle or "<unranked>").." (rank advancement: "..change..")";
				end
			end

--			DEFAULT_CHAT_FRAME:AddMessage(standing..") "..player.name.." ("..player.class..") - HKs: "..player.HKs.." - CP: "..player.contribution.." - Avg. CP/kill: "..string.format("%i", (player.contribution / player.HKs)));
			DEFAULT_CHAT_FRAME:AddMessage("|c0000ffff"..standing.."|r) |c0000ffff"..(player.ranktitle or "<unranked>").."|r ("..string.format("%i", (player.progress * 100)).."%) |c0000ff00"..player.name.."|r ("..player.class..") - HKs: |c00ffff00"..player.HKs.."|r - Honor: |c00ffff00"..player.contribution.."|r"..wbltext);
		end
		
		if ( count >= 100 ) then
			DEFAULT_CHAT_FRAME:AddMessage("... limit of 100 reached");
			break;
		end
	end

	-- unranked use their name as map keys
	if ( smax == 9999 ) then
	
		for k, player in pairs(HKC_Standings[HKC_Server]) do
		
			if ( not tonumber(k) ) then
			
				count = count + 1;

				wbltext = "";
				-- iterate through week before last standings
				for wblstanding, wblplayer in pairs(HKC_WBLStandings[HKC_Server]) do

					-- if player found in week before last standings array
					if (wblplayer.name == player.name) then
						
						-- get exact change in rank for player
						change = (player.ranknum + player.progress) - (wblplayer.ranknum + wblplayer.progress);
						change = string.format("%.2f", (change));

						wbltext = "; Last Week Rank: "..string.format("%i", (wblplayer.progress * 100)).."% into "..(wblplayer.ranktitle or "<unranked>").." (rank advancement: "..change..")";
					end
				end

				DEFAULT_CHAT_FRAME:AddMessage("|c0000ffff"..(player.ranktitle or "<unranked>").."|r ("..string.format("%i", (player.progress * 100)).."%) |c0000ff00"..player.name.."|r ("..player.class..") - HKs: |c00ffff00"..player.HKs.."|r - Honor: |c00ffff00"..player.contribution.."|r"..wbltext);
			end
			
			if ( count >= 100 ) then
				DEFAULT_CHAT_FRAME:AddMessage("... limit of 100 reached");
				break;
			end
		end
	end
end

function HKCLastWeekStandings(range)
	local standing, player, smin, smax, wblstanding, wbltext, wblplayer, change;
	local defaultMax = 9999;
	local count = 0;

	if (not range) then
		smin = 1;
		smax = defaultMax;
	else
		_, _, smin, smax = string.find(range, "(%d+)%s*%-%s*(%d+)");
		if (not smin) then
			-- single standing?
			_, _, smin = string.find(range, "^(%d+)$");
			if (smin) then
				smax = smin;
			end
		end
		smin = tonumber(smin);
		smax = tonumber(smax);
		if (not smin or not smax or smax < smin) then
			smin = 1;
			smax = defaultMax;
		end
	end

	DEFAULT_CHAT_FRAME:AddMessage("Currently known "..smin.."-"..smax.." last week standings:", 1, 1, 0);

	for standing = smin, smax do
	
		if (HKC_WBLStandings[HKC_Server][standing]) then
		
			count = count + 1;
			player = HKC_WBLStandings[HKC_Server][standing];

			DEFAULT_CHAT_FRAME:AddMessage("|c0000ffff"..standing.."|r) |c0000ffff"..(player.ranktitle or "<unranked>").."|r ("..string.format("%i", (player.progress * 100)).."%) |c0000ff00"..player.name.."|r ("..player.class..") - HKs: |c00ffff00"..player.HKs.."|r - Honor: |c00ffff00"..player.contribution.."|r");
		end
		
		if ( count >= 100 ) then
			DEFAULT_CHAT_FRAME:AddMessage("... limit of 100 reached");
			break;
		end
	end

	-- unranked use their name as map keys
	if ( smax == 9999 ) then
	
		for k, player in pairs(HKC_WBLStandings[HKC_Server]) do
		
			if ( not tonumber(k) ) then
			
				count = count + 1;

				DEFAULT_CHAT_FRAME:AddMessage("|c0000ffff"..(player.ranktitle or "<unranked>").."|r ("..string.format("%i", (player.progress * 100)).."%) |c0000ff00"..player.name.."|r ("..player.class..") - HKs: |c00ffff00"..player.HKs.."|r - Honor: |c00ffff00"..player.contribution.."|r");
			end
			
			if ( count >= 100 ) then
				DEFAULT_CHAT_FRAME:AddMessage("... limit of 100 reached");
				break;
			end
		end
	end
end

function HKCStandingsGUI()

	HKC_FrameText = {};
	local player, line, nameColor, c, standing, rank, adv, advText;
	local order = {};
	
	for standing = 1, 9999 do
		if ( HKC_Standings[HKC_Server][standing] ) then
			table.insert(order, standing);
		end
	end
	for k, player in pairs(HKC_Standings[HKC_Server]) do
		if ( not tonumber(k) ) then
			table.insert(order, player.name);
		end
	end
	
	for _, k in ipairs(order) do
	
		if ( HKC_Standings[HKC_Server][k] ) then

			if ( tonumber(k) ) then
				standing = k;
			else
				standing = 0;
			end
			player = HKC_Standings[HKC_Server][k];
			rank = player.ranknum + player.progress;
			rank = rank - (rank % 0.01);
			advText = "";
			
			if ( RAID_CLASS_COLORS[player.class:upper()] ) then
				c = RAID_CLASS_COLORS[player.class:upper()];
				nameColor = string.format("\124c00%.2x%.2x%.2x", c.r*255, c.g*255, c.b*255);
			else
				nameColor = "|c0000ff00";
			end

			for wblstanding, wblplayer in pairs(HKC_WBLStandings[HKC_Server]) do

				if ( wblplayer.name == player.name ) then
					
					adv = (player.ranknum + player.progress) - (wblplayer.ranknum + wblplayer.progress);
					adv = adv - (adv % 0.01);
					advText = "(";
					if ( adv >= 0 ) then
						advText = advText.."|c0000ff00+";
					else
						advText = advText.."|c00ff0000";
					end
					advText = advText..adv.."|r) ";

				end
			end

			line = "|c0000ffff"..(standing or "(nil)").."|r) "
			..nameColor..(player.name or "(nil)").."|r - Rank: |c0000ffff"..(rank or "(nil)").."|r "
			..advText.." - Honor: |c00ffff00"..(player.contribution or "(nil)").."|r";
			
			table.insert(HKC_FrameText, line);
		end
	end
end

function HKCRank(range)
	local standing, player, smin, smax, wblstanding, wbltext, wblplayer, change;

	if (not range) then
		_, smin = GetPVPRankInfo(UnitPVPRank("player"));
		smax = smin;
	elseif (tonumber(range) ~= nil and tonumber(range) >= 1 and tonumber(range) <= 14) then
		smin = tonumber(range);
		smax = tonumber(range);
	else
		_, _, smin, smax = string.find(range, "(%d+)%s*%-%s*(%d+)");
		smin = tonumber(smin);
		smax = tonumber(smax);
		if (not smin or not smax or smax < smin) then
			_, smin = GetPVPRankInfo(UnitPVPRank("player"));
			smax = smin;
		end
	end

	if (smin == smax) then
		DEFAULT_CHAT_FRAME:AddMessage("Showing inspected players for rank "..smin..":", 1, 1, 0);
	else
		DEFAULT_CHAT_FRAME:AddMessage("Showing inspected players for ranks "..smin.."-"..smax..":", 1, 1, 0);
	end

	local rankarr = {};
	
	for standing, player in pairs(HKC_Standings[HKC_Server]) do
		table.insert(rankarr, player);
	end

	table.sort(rankarr, 
		function(a, b)
			if (a.ranknum == b.ranknum) then
				return a.progress > b.progress;
			else
				return a.ranknum > b.ranknum;
			end
		end
	);

	for standing, player in ipairs(rankarr) do
		if (player.ranknum >= smin and player.ranknum <= smax) then

			wbltext = "";
			-- iterate through week before last standings
			for wblstanding, wblplayer in pairs(HKC_WBLStandings[HKC_Server]) do

				-- if player found in week before last standings array
				if (wblplayer.name == player.name) then
					
					-- get exact change in rank for player
					change = (player.ranknum + player.progress) - (wblplayer.ranknum + wblplayer.progress);
					change = string.format("%.2f", (change));

					wbltext = "; Last Week Rank: "..string.format("%i", (wblplayer.progress * 100)).."% into "..(wblplayer.ranktitle or "<unranked>").." (rank advancement: "..change..")";
				end
			end

			DEFAULT_CHAT_FRAME:AddMessage("|c0000ffff"..(player.ranktitle or "<unranked>").."|r ("..string.format("%i", (player.progress * 100)).."%) |c0000ff00"..player.name.."|r ("..player.class..") - HKs: |c00ffff00"..player.HKs.."|r - Honor: |c00ffff00"..player.contribution.."|r"..wbltext);
		end
	end

end

function HKCZeroed()
	local name, kills;

	DEFAULT_CHAT_FRAME:AddMessage("These people no longer give you honor for today:", 1, 1, 0);

	for name, kills in pairs(HKC_KillsToday) do
		if (kills > 3) then
			DEFAULT_CHAT_FRAME:AddMessage(name.." ("..kills..")");
		end
	end
end

function HKCInfo()
	local kills, z, hk, contribution;

	-- people killed today
	z = 0;
	for _ in pairs(HKC_KillsToday) do
		z = z + 1;
	end
	DEFAULT_CHAT_FRAME:AddMessage("You killed |c0000ffff"..z.."|r players today.", 1, 1, 0);

	-- people killed lifetime
	z = 0;
	for _ in pairs(HKC_KillsLifetime) do
		z = z + 1;
	end
	DEFAULT_CHAT_FRAME:AddMessage("You killed |c0000ffff"..z.."|r players on your server since HKC was installed.", 1, 1, 0);

	z = 0;
	for _ in pairs(HKC_Standings[HKC_Server]) do
		z = z + 1;
	end
	DEFAULT_CHAT_FRAME:AddMessage("You have inspected the honor of |c0000ffff"..z.."|r players this week.", 1, 1, 0);

	z = 0;
	for _ in pairs(HKC_WBLStandings[HKC_Server]) do
		z = z + 1;
	end
	DEFAULT_CHAT_FRAME:AddMessage("You inspected the honor of |c0000ffff"..z.."|r players last week.", 1, 1, 0);

	-- Avg contribution
	-- Yesterday's values
--	hk, _, contribution = GetPVPYesterdayStats();
--	if (hk > 0) then
--		DEFAULT_CHAT_FRAME:AddMessage("Yesterday's avg contribution per kill: "..string.format("%.1f", (contribution / hk)).." ", 1, 1, 0);
--	end
	-- Last Week's values
--	hk, _, contribution = GetPVPLastWeekStats();
--	if (hk > 0) then
--		DEFAULT_CHAT_FRAME:AddMessage("Last week's avg contribution per kill: "..string.format("%.1f", (contribution / hk)).." ", 1, 1, 0);
--	end

	-- number of people who no longer give contribution for today
	z = 0;
	for _, kills in pairs(HKC_KillsToday) do
		if (kills > 3) then
			z = z + 1;
		end
	end
	DEFAULT_CHAT_FRAME:AddMessage("There are |c0000ffff"..z.."|r players who will no longer give you honor for today.", 1, 1, 0);

	-- BG avgs
	--[[
	local bg, honorArr, avgHonor, avgTime, bgSession, dataPoints;

	for bg, honorArr in HKCBGHonorHistory do
		avgHonor = 0;
		avgTime = 0;

		dataPoints = table.getn(honorArr);

		for _, bgSession in honorArr do
			avgHonor = avgHonor + bgSession.honor;
			avgTime = avgTime + bgSession.time;
		end

		avgHonor = math.floor(avgHonor / dataPoints);
		avgTime = math.floor(avgTime / dataPoints);

		DEFAULT_CHAT_FRAME:AddMessage("|c00ffffff"..bg.."|r Avg Honor: |c0000ffff"..avgHonor.."|r  Avg Time: |c0000ffff"..avgTime.."|r (last "..dataPoints..")", 1, 1, 0);
	end
	]]

	DEFAULT_CHAT_FRAME:AddMessage("Today's honor before diminishing returns: |c0000ffff"..HKC_PlayerData.blizzHonorToday.."|r", 1, 1, 0);
	DEFAULT_CHAT_FRAME:AddMessage("HKC's Estimated honor for today: |c0000ffff"..HKC_PlayerData.honorToday.."|r", 1, 1, 0);

	-- if in a BG, show honor gained so far
	--[[
	if (HKCInBattleground) then
		local gained = math.floor(HKC_CFG[HKC_PLAYER].ESTCP.HKCtoday - HKCLastEstimated);
		DEFAULT_CHAT_FRAME:AddMessage("Honor gained in your current BG thus far: |c0000ffff"..gained.."|r", 1, 1, 0);
	end
	]]
end

function HKCPlot(rank)
	local player, wblplayer, change, i;
	local points = 0;

	if (not rank) then
		_, rank = GetPVPRankInfo(UnitPVPRank("player"));
	elseif (tonumber(rank) ~= nil and tonumber(rank) >= 0 and tonumber(rank) <= 14) then
		rank = tonumber(rank);
	else
		_, rank = GetPVPRankInfo(UnitPVPRank("player"));
	end

	local datapoint = {};

	-- iterate last weeks' standings
	i = 0;
	for _, wblplayer in pairs(HKC_WBLStandings[HKC_Server]) do

		-- if player was the rank specified
		if (wblplayer.ranknum == rank) then

			-- iterate through current standings
			for standing, player in pairs(HKC_Standings[HKC_Server]) do

				-- if player found in both arrays
				if (wblplayer.name == player.name) then
					
					-- get exact change in rank for player
					change = (player.ranknum + player.progress) - (wblplayer.ranknum + wblplayer.progress);

					table.insert(datapoint, {
						name = player.name,
						honor = player.contribution,
						change = change,
						wblprogress = math.floor(wblplayer.progress * 100),
						standing = standing,
					});
					points = points + 1;
				end
			end

		end

		i = i + 1;
	end

	if (i < 1) then
		DEFAULT_CHAT_FRAME:AddMessage("This feature requires you to have inspected the honor of the same players this week and last week", 1, 0, 0);
		return
	end

	table.sort(datapoint, 
		function(a, b)
			return a.honor > b.honor;
		end
	);

	local minHonor = 9999999;
	local maxHonor = 0;
	local minChange = 10;
	local maxChange = -1;

	DEFAULT_CHAT_FRAME:AddMessage("Plot data for rank "..rank..":", 1, 1, 0);

	for _, player in ipairs(datapoint) do
		if (player.honor > maxHonor) then
			maxHonor = player.honor;
		end
		if (player.honor < minHonor) then
			minHonor = player.honor;
		end
		if (player.change > maxChange) then
			maxChange = player.change;
		end
		if (player.change < minChange) then
			minChange = player.change;
		end

		change = string.format("%.2f", (player.change));
		--DEFAULT_CHAT_FRAME:AddMessage("|c0000ffff"..player.honor.."|r honor at "..player.wblprogress.."% into the rank resulted in a rank change of |c0000ffff"..change.."|r");
	end

	for i = 1, 40 do
		getglobal("HKCDataPlot"..i):Hide();
	end

	-- hide what possibly might not be shown
	HKCGraphLinenp5:Hide();
	HKCGraphLineZero:Hide();
	HKCGraphLine1p5:Hide();
	HKCGraphLine1:Hide();
	HKCGraphLine2:Hide();
	HKCGraphLine2p5:Hide();
	HKCGraphLine3:Hide();
	HKCGraphLine3p5:Hide();
	HKCGraphLine4:Hide();

	HKCGraphFrameYnp5:Hide();
	HKCGraphFrameYZero:Hide();
	HKCGraphFrameY1p5:Hide();
	HKCGraphFrameY2:Hide();
	HKCGraphFrameY2p5:Hide();
	HKCGraphFrameY3:Hide();
	HKCGraphFrameY3p5:Hide();
	HKCGraphFrameY4:Hide();

	if (points > 1) then
		local minY, maxY, minX, maxX;
		local x, y, xUnit, yUnit, width;

		HKCGraphFrame:Show();

		-- display 0, .5, 1 labels
		local yLabels = {
			{ val = 0, global = "Zero"},
			{ val = .5, global = "p5"},
			{ val = 1, global = "1"}
		};

		-- determine min and max Y scale
		-- and labels
		if (minChange < 0) then
			minY = -.5;
			table.insert(yLabels, { val = -.5, global = "np5"});
		else
			minY = 0;
		end

		maxY = 1;
		if (maxChange > 1) then
			maxY = 1.5;
			table.insert(yLabels, { val = 1.5, global = "1p5"});
		end
		if (maxChange > 1.5) then
			maxY = 2;
			table.insert(yLabels, { val = 2, global = "2" });
		end
		if (maxChange > 2) then
			maxY = 2.5;
			table.insert(yLabels, { val = 2.5, global = "2p5" });
		end
		if (maxChange > 2.5) then
			maxY = 3;
			table.insert(yLabels, { val = 3, global = "3" });
		end
		if (maxChange > 3) then
			maxY = 3.5;
			table.insert(yLabels, { val = 3.5, global = "3p5" });
		end
		if (maxChange > 3.5) then
			maxY = 4;
			table.insert(yLabels, { val = 4, global = "4" });
		end
		if (maxChange > 4) then
			maxY = 4.5;
		end

		-- x axis (honor) minimum
		minX = 0;

		-- determine x axis maximum
		maxX = 10 ^ (string.len(tostring(maxHonor)) - 1);
		maxX = math.ceil(maxHonor / maxX) * maxX;

		-- X (honor) scale labels
		HKCGraphFrameX1Label:SetText(minX);
		HKCGraphFrameX2Label:SetText(((maxX - minX) * 0.25) + minX);
		HKCGraphFrameX3Label:SetText(((maxX - minX) / 2) + minX);
		HKCGraphFrameX4Label:SetText(((maxX - minX) * 0.75) + minX);
		HKCGraphFrameX5Label:SetText(maxX);

		xUnit = (maxX - minX) / 500;	-- 1 pixel = this many X.  graph = 500x500
		yUnit = (maxY - minY) / 500;	-- 1 pixel = this many Y

		-- draw honor grid lines
		DrawLine(HKCGraphLineX1, "HKCGraphFrame", 250, 6, 250, 494, 10, TAXIROUTE_LINEFACTOR);
		DrawLine(HKCGraphLineX2, "HKCGraphFrame", 125, 6, 125, 494, 10, TAXIROUTE_LINEFACTOR);
		DrawLine(HKCGraphLineX3, "HKCGraphFrame", 375, 6, 375, 494, 10, TAXIROUTE_LINEFACTOR);
		
		HKCGraphLineX1:SetVertexColor(1, 1, 1);
		HKCGraphLineX2:SetVertexColor(1, 1, 1);
		HKCGraphLineX3:SetVertexColor(1, 1, 1);

		-- draw rank lines and position labels
		for _, i in ipairs(yLabels) do
			if (maxY >= i.val and minY <= i.val) then
				-- set label
				y = math.floor((i.val + math.abs(minY)) / yUnit);
				getglobal("HKCGraphFrameY"..i.global):SetPoint("LEFT", "HKCGraphFrame", "BOTTOMLEFT", 5, (y + 2));
				getglobal("HKCGraphFrameY"..i.global):SetTextColor(1, 1, 1);
				getglobal("HKCGraphFrameY"..i.global):Show();
			end
			if (maxY > i.val and minY < i.val) then
				-- draw line
				if (i.val == 0) then
					width = 12;
					HKCGraphLineZero:SetVertexColor(1, 0, 0);
				else
					getglobal("HKCGraphLine"..i.global):SetVertexColor(1, 1, 1);
					width = 12;
				end
				DrawLine(getglobal("HKCGraphLine"..i.global), "HKCGraphFrame", 6, y, 494, y, width, TAXIROUTE_LINEFACTOR);
				getglobal("HKCGraphLine"..i.global):Show();
			end
		end

		-- plot data points
		i = 0;
		local plot;
		for _, player in ipairs(datapoint) do
			i = i + 1;

			-- 40 points max
			if (i > 40) then
				break;
			end

			x = math.floor((player.honor - minX) / xUnit);
			y = math.floor((player.change - minY) / yUnit);

			plot = getglobal("HKCDataPlot"..i);
			plot:SetPoint("CENTER", "HKCGraphFrame", "BOTTOMLEFT", x, y);
			plot.playerName = player.name;
			plot.standing = player.standing;
			if ( not tonumber(player.standing) ) then
				plot.standing = 0;
			end
			plot.honor = player.honor;
			plot.change = player.change - (player.change % 0.01);
			plot:Show();
		end

		HKCGraphFrameTitle:SetText("Rank "..rank.." Progression");

	else
		HKCGraphFrame:Hide();
		DEFAULT_CHAT_FRAME:AddMessage("Insufficient standings data to display plots", 1, 0, 0);
	end

end

function HKCOptionsCheckButtonToggle(id, state)
	if ( id == 5 ) then -- enable movable frame
		if ( state ) then
			HKCFrame:SetMovable(true);
		else
			HKCFrame:SetMovable(false);
			HKCFrame:ClearAllPoints();
			HKCFrame:SetPoint("LEFT", "HonorFrame", "RIGHT", 0, 0);
		end
	end
end
